;termometr DS18B20
; PIC16F876A
;
;brak czujnika temperatury = minutnik
;
; minutnik
; jeli po reset trzymamy key - ustawiamy ile minut ma odliczy
; po puszczeniu key - pojawia si kropka i zaczyna odliczac
;
;obsluga wyswietlacz 7seg LCD
;przerwanie od TMR0
;BUZ=>on - option_reg:=00 bank1, int_div:=80h (byl 08h)
;
;definiowanie staych
;
;definiowanie zmiennych
#define LCD_COM PORTA, 1	;BACK GROUND LCD
#define LCD_K PORTA, 0		;LCD K - setka stopni
#define LCD_C PORTA, 5		;    LCD - C STOPNIE
#define DS_DATA PORTA, 3	; szyna danych czujnika temp. byl PORT A.0
#define Vdd_DS18B PORTA, 2	; +  zasilania DS18B20
#define BUZ PORTA, 4		;BUZER
#define KEY PORTB, 7		;KEY - MEM
;
#define dph 20h				;starszy bajt pomocniczy
#define dpl 21h				;mlodszy bajt pomocniczy
#define licznik 22h				;mlodszy bajt pomocniczy
#define stos 23h				;mlodszy bajt pomocniczy
#define stos1 24h				;mlodszy bajt pomocniczy
#define stos3 25h				;mlodszy bajt pomocniczy
#define background 26h			;to samo co na COM LCD - do mnoenia liczb
#define LCDx1 27h					;kmorka pierwszej cyfry LCD, 1 zapala segment
#define LCDx2 28h					;kmorka pierwszej cyfry LCD, 2 zapala segment
#define LCDx3 29h					;kmorka pierwszej cyfry LCD, 3 zapala segment
#define LCDx4 2Ah					;kmorka pierwszej cyfry LCD, 4 zapala segment
#define licznik1 2Bh
#define pom1 2Ch				;rejestr pomocniczy uzywany tylko w biezacej funkci
#define bit_reg 2Dh				;rejestr bitowy bit_reg.0 =1 bylo przerwanie
#define int_div 2Eh				; stala wpisywanana do tmr0 = przeladowanie licznika
#define int_timer bit_reg, 0	;bit ustawiany po przerwaniu od timera
#define dp2 bit_reg, 1			;znaznk alarmu 1 = alarm
#define dp3 bit_reg, 2			;funkcja timer 1 - timer on
#define dp4 bit_reg, 3			;start minutnika - 1 = start minutnika
#define start_stoper bit_reg, 4	;znacznik startu stopera
#define stop_stoper bit_reg, 5	;znacznik stop stopera
;
#define x1ms 2eh				;pamieci jednostek ms
#define DS_WORD 2fh				;adres eeprom
#define point 30h				;01 = brak przecinka; 02 = przecinek po 2 cyfrze; 04 = przecinek po 3 cyfrze
#define x1s 31h					;pamieci jednostek s
#define x10s 32h				;x1C
#define x100s 33h				;x10C
#define x1000s 34h				;x100C
;
#define time1 35h				; do minutnika licznik pomocniczy
#define time2 36h				; do minutnika licznik pomocniczy
#define temp_ref 37h			; prog temp, przekroczenie - alarm
;
;kody znakw
#define minus_LCD 0Ah			;znak - jest na pozycji A w tabeli
#define F_LCD 0Ch				;znak F jest na pozycji C w tabeli
#define U_LCD 0Dh				;znak U jest na pozycji D w tabeli
#define L_LCD 0Eh				;znak L jest na pozycji E w tabeli
#define H_LCD 0Fh				;znak H jest na pozycji F w tabeli
#define E_LCD 010h				;znak E jest na pozycji 10 w tabeli
#define P_LCD 011h				;znak P jest na pozycji 11 w tabeli
#define d_LCD 012h				;znak d jest na pozycji 12 w tabeli
#define A_LCD 013h				;znak A jest na pozycji 13 w tabeli
#define n_LCD 014h				;znak n jest na pozycji 14 w tabeli
#define S_LCD 015h				;znak S jest na pozycji 15 w tabeli
;**********************************
#define READ_SCRATCHPAD 0BEh	;
#define READ_ROM 033h	;
#define CONVERT_TEMPERATURE 044h; 
;
;deklaracj typu procesora i formatu liczb
	list p=16F876A			;okreslenie typu procesora
	#include p16f876A.inc	;dolaczenie pliku z nazwami

;konfiguracja procesora
__config _XT_OSC &_WDT_OFF &_PWRTE_OFF &_BODEN_OFF &_DEBUG_OFF &_CP_OFF &_CPD_OFF &_LVP_OFF;
;OSC:
;	LP - low power - zewnetrzny kwarc zegarkowy 32kHz
;	XT - kwarc 455kHz - 4MHz
;	HS - kwarc 8-16MHz
;	RS - zewnetrzny RC
;
;WDT - WATCHDOG
;PWRTE - ON - po wlazeniu zasilania 72ms zwloki (reset) do ustabilizowania napicia
;BODEN - reset przy obnizebiu Udd - wylacz dla 3,3V
;CP - ochrona pamici programu przed odczytem
;CPD - ochrona pameci eeprom przed odczytem
;LVP - off programowanie z ISP - RB3 I/O
;
org 0
	goto start
org h'04'
	call timer0_int
	retfie
;
;tablica znakow LCD druga CYFRA lcdx3 - jednosci 
;		 	g f a b c d e nc 	PORTC 
TAB_LCDX3 
	ADDWF PCL, 1
	RETLW b'01111110'	;  lcd1=0	1<=>zapala segment
	RETLW b'00011000'	;  lcd1=1
	RETLW b'10110110'	;  lcd1=2
	RETLW b'10111100'	;  lcd1=3
	RETLW b'11011000'	;  lcd1=4
	RETLW b'11101100'	;  lcd1=5
	RETLW b'11101110'	;  lcd1=6
	RETLW b'00111000'	;  lcd1=7
	RETLW b'11111110'	;  lcd1=8
	RETLW b'11111100'	;  lcd1=9
	RETLW b'10000000'	;  lcd1= minus
	RETLW b'00000000'	;  lcd1= black
	RETLW b'11100010'	;  lcd1= F
	RETLW b'01011110'	;  lcd1= U
	RETLW b'01000110'	;  lcd1= L
	RETLW b'11011010'	;  lcd1= H
	RETLW b'11100110'	;  lcd1= E 10
	RETLW b'11110010'	;  lcd1= P 11
	RETLW b'10011110'	;  lcd1= d 12
	RETLW b'11111011'	;  lcd1= A 13
	RETLW b'10001010'	;  lcd1= n 14
;tablica znakow LCD druga CYFRA lcdx2 - dziesiatki
;		nc e d c g f a b 		PORTB 	
TAB_LCDX2 
	ADDWF PCL, 1
	RETLW b'11110111'	;  lcd1=0
	RETLW b'10010001'	;  lcd1=1
	RETLW b'11101011'	;  lcd1=2
	RETLW b'10111011'	;  lcd1=3
	RETLW b'10011101'	;  lcd1=4
	RETLW b'10111110'	;  lcd1=5
	RETLW b'11111110'	;  lcd1=6
	RETLW b'10010011'	;  lcd1=7
	RETLW b'11111111'	;  lcd1=8
	RETLW b'10111111'	;  lcd1=9
	RETLW b'10001000'	;  lcd1= minus
	RETLW b'10000000'	;  lcd1= black
	RETLW b'11111111'	;  lcd1= F
	RETLW b'11111111'	;  lcd1= U
	RETLW b'11111111'	;  lcd1= L
	RETLW b'11111111'	;  lcd1= H
	RETLW b'11111111'	;  lcd1= E	
	RETLW b'11111111'	;  lcd1= P	
	RETLW b'11111111'	;  lcd1= d
	RETLW b'11111111'	;  lcd1= A
	RETLW b'11111111'	;  lcd1= n
start
	bcf status, rp0		;bank 0
	bcf status, rp1		;bank 0
	clrf portb			;wyzerowanie portu zatrzaskowego portu B
	clrf porta			;wyzerowanie portu zatrzaskowego portu D
	bcf intcon, gie		;wylaczenie przerwan
	bcf intcon, tmr0ie		
	bcf status, rp1		;bank
	bsf status, rp0		;bank1
	movlw b'10000000'			
	movwf trisb			;wyjscie
	movlw b'11000000'			; 
	movwf trisa			;wyjscia; AN0 - wejscie komp.!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	movlw h'00'			; 
	movwf trisc			;wyjscia
	bcf option_reg, 7	;wlaczenie rezystorow podciagajacych
	bsf pcon, 0			;BOR OFF
	bcf status, rp1		;bank0
	bcf status, rp0		;bank0
	movlw h'00'			; 
	movwf sspcon 		;wyjscia
	movlw h'00'			; 
	movwf ccp2con 		;PWM2 i Comparator2 off
;
	movlw h'00'			; 
	movwf ccp1con 		;PWM1 i Comparator1 off
;
	bsf status, rp0		;bank 1
	bcf status, rp1		;bank 1
	movlw b'00000000'			; 
	movwf sspstat 		;I2C 
	movlw b'0000000'			; 
	movwf sspcon2 		;I2C off - udostepnienie linii SDA i CLK
	bcf status, rp1		;bank 0
	bcf status, rp0		;bank 0
	movlw b'00001000'			; 
	movwf sspcon 		;I2C off - udostepnienie linii SDA i CLK
;
	movlw h'00'			; 
	movwf rcsta 		;serial port off
	movlw h'00'			; 
	movwf t1con 		;timer 1 off
	movlw h'00'			; 
	movwf t2con 		;timer 2 off
	bcf status, rp1		;bank1
	bsf status, rp0		;bank1
	movlw b'00000110'	; rezystory wlaczone; timer fosc/4/2 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	movwf option_reg 		
	bcf status, rp1		;bank1
	bcf status, rp0		;bank0
;
	bcf status, rp1		;bank1
	bsf status, rp0		;bank1
	movlw b'00000110'	;portA cyfrowy	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	movwf adcon1 		;
	movlw b'11000000'	;
	movwf trisa
	movlw b'10001000'	;Vref On, =1/2 Vdd
	movwf cvrcon		;
	movlw b'00000111'	;wylacz komparator;
	movwf cmcon		;
	bcf status, rp1		;bank1
	bcf status, rp0		;bank0
	movlw b'10000000'	;ADC - OFF
	movwf adcon0 		;
;
;****************************************************
;glowna petla programu
	movf tmr0, 0
	addlw h'08'
	movwf tmr0
	movlw b'10100000'	;  
	movwf intcon	;przerwanie od timera - inne zablokowane 
;
	bcf status, rp1		;bank0
	bcf status, rp0		;bank0
	clrf x1s
	clrf lcdx1
	clrf lcdx2
	clrf lcdx3
	clrf lcdx4
	clrf DS_WORD; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;************************************************
	bcf status, rp1		;bank0
	bcf status, rp0		;bank0
	bcf intcon, gie	; start przewan od timera	
	bcf status, rp1		;bank1
	bsf status, rp0		;bank1
	movlw b'10000000'
	movwf trisb		
	movlw b'11000000'	;0-out
	movwf trisa		
	bcf status, rp1		;bank1
	bcf status, rp0		;bank0
;
	movlw h'64'	; 25Hz !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	movwf int_div		;wpis staej tmr0
	bsf BUZ
	bsf KEY
	bcf dp2			;kasowanie znacznika od alarmu
	bcf dp3			;kasowanie znacznika minutnika
	bcf dp4			; bit startu minutnika 
	bcf status, rp1		;bank1
	bsf status, rp0		;bank1
	movlw b'11001000'	;DS_data  input
	movwf trisa			;
	bcf status, rp1		;bank1
	bcf status, rp0		;bank0
	btfss DS_DATA
	bsf dp3
	bcf status, rp1		;bank1
	bsf status, rp0		;bank1
	movlw b'11000000'	;DS_data  OUTPUT
	movwf trisa			;
	bcf status, rp1		;bank1
	bcf status, rp0		;bank0	
;***************************************************
	btfsc dp3
	goto menut0
	btfss key
	goto menut0
menu0
;	movlw h'00'
	call eeprom_read
	movwf temp_ref
	call delay500
	call delay500
menu0a
;
	movf x10s, 0
	call TAB_LCDX3	; zawarto W na LCD 3 cyfra (jednsci)
	movwf lcdx3
;
	movf x100s, 0
	call TAB_LCDX2	; zawarto W na LCD 2 cyfra (dziesiatki)
	movwf lcdx2
;
	bcf status, rp1		;bank1
	bcf status, rp0		;bank0
	bcf Vdd_DS18b
	call delay100ms
	bcf intcon, gie	; start przewan od timera	
	call POM
	bcf status, rp1		;bank1
	bcf status, rp0		;bank0
	btfss dp2
	call COMPARE_TEMP
;
	bsf Vdd_DS18b
	bsf intcon, gie	; start przewan od timera
	btfss dp2
	goto menu0
	call delay100ms	;sygnal 1
	bcf dp2
	bsf BUZ
	call delay100ms
	bsf dp2
	call delay100ms	; sygnal 2
	bcf dp2
	bsf BUZ
	call delay100ms
	bsf dp2
	call delay100ms	; sygnal 3
	bcf dp2
	bsf BUZ
	call delay500
	call delay500
	bsf dp2
	goto menu0a
;****************************************************************
; minutnik timer
menut0:
	movlw h'65' ;	;	99 - min	
	movwf DS_WORD
	movlw h'05'	;	
	movwf time1	;	timer1 przepelnia sie co 5 sec
	movlw h'F4'	;	
	movwf time2	;	timer1 przepelnia sie co 5 sec
	call counter
;
	bcf status, rp1		;bank1
	bcf status, rp0		;bank0
	bsf intcon, gie	; start przewan od timera
	call delay500
menut1a
	btfsc KEY
	goto menut1		;nie by nacisniety key -> odliczanie
	decf DS_WORD, 1		
	call counter
	movf x10s, 0
	call TAB_LCDX3	; zawarto W na LCD 3 cyfra (jednsci)
	movwf lcdx3
;
	movf x100s, 0
	call TAB_LCDX2	; zawarto W na LCD 2 cyfra (dziesiatki)
	movwf lcdx2
	call delay100ms
	call delay100ms
	call delay100ms
	btfsc dp3
	goto menut1a
	call delay500
;	call delay500
	goto menut1a
;dupa
menut1
	btfsc dp3
	goto menut1b
	movf DS_WORD, 0
	call eeprom_write
	goto menu0
menut1b
	bsf dp4
	call counter
	call delay100ms
;
	movf x10s, 0
	call TAB_LCDX3	; zawarto W na LCD 3 cyfra (jednsci)
	movwf lcdx3
;
	movf x100s, 0
	call TAB_LCDX2	; zawarto W na LCD 2 cyfra (dziesiatki)
	movwf lcdx2
;
	incf DS_WORD, 1
	decfsz DS_WORD		
	goto menut1
	bcf status, rp1		;bank1
	bsf status, rp0		;bank0
	clrf option_reg
	bcf status, rp0		;bank0
	movlw h'80'	;
	movwf int_div
	bsf dp2			;wlaczene alarmu
	call counter
;
	movf x10s, 0
	call TAB_LCDX3	; zawarto W na LCD 3 cyfra (jednsci)
	movwf lcdx3
;
	movf x100s, 0
	call TAB_LCDX2	; zawarto W na LCD 2 cyfra (dziesiatki)
	movwf lcdx2
menut_end
	call delay100ms	;sygnal 1
	bcf dp2
	bsf BUZ
	call delay100ms
	bsf dp2
	call delay100ms	; sygnal 2
	bcf dp2
	bsf BUZ
	call delay100ms
	bsf dp2
	call delay100ms	; sygnal 3
	bcf dp2
	bsf BUZ
	call delay500
	call delay500
	bsf dp2
	goto menut_end
;****************************************************************
;FUNKCJE POMOCNICZE CD.
;*****************************************************************
;obsluga timera
timer0_int
	movwf stos
	swapf status,w
	movwf stos1
	bcf status, rp0		;bank0
	bcf status, rp1		;bank0
	movf tmr0, 0
	addwf int_div,0	;
	movwf tmr0
	bsf int_timer		;ustawienie znacznika przerwania od timera
;
	incf background, 1			;background!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	btfss background, 0
	goto t0i1
	bsf LCD_COM
	bsf LCD_C 
	btfss dp3
	bcf LCD_C
	bsf LCD_K		;bsf nie swieci
	btfsc x1000s, 0
	bcf LCD_K
	movlw h'ff'
	movwf background
	goto t0i_end
t0i1
	bcf LCD_COM
	bcf LCD_C ;
	btfss dp3
	bsf LCD_C
	bcf LCD_K		;bcf nie swieci
	btfsc x1000s, 0
	bsf LCD_K
	clrf background
t0i_end					;
	movf background, 0
	xorwf lcdx3, 0
	movwf portc	 	;piny sterujace cyfra nr 2 ma by port C 
	movf background, 0
	xorwf lcdx3, 0
	movf background, 0
	xorwf lcdx2, 0
	movwf portb
;
	bsf pom1, 2
	btfss bit_reg, 2
 	bcf pom1, 2
	movf background, 0
	xorwf pom1, 1
	btfss pom1, 2
;
	bsf pom1, 3
	btfss bit_reg, 3
 	bcf pom1, 3
	movf background, 0
	xorwf pom1, 1
;
	btfss dp4		;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	goto t0i_end1
	bsf portc, 0
	btfss background, 0
	goto t0i_end1
	bcf portc, 0	
t0i_end1
	btfss dp2			;czy by alarm?
	goto t0i_end2 
	incf lcdx4, 1
	bcf BUZ
	btfsc lcdx4, 0
	bsf BUZ	
t0i_end2
	btfss dp3
	goto t0i_end3
	btfss dp4
	goto t0i_end3	
	movlw h'01'	; 1
	addwf time1, 1
	btfss status, c
	goto t0i_end3
	movlw h'05'	; 1
	movf time1		;time1 przepelnia sie co 5 sec
	movlw h'01'	; 1
	addwf time2, 1
	btfss status, c
	goto t0i_end3
	movlw h'F4'	;	
	movwf time2	;	timer1 przepelnia sie co 5 sec
	decf DS_WORD, 1
t0i_end3
	swapf stos1,w
	movwf status
	swapf stos,1
	swapf stos,w
	bcf intcon, tmr0if	;	zerowanie wskaxnika od przerwania	
	return
;
;opoznienie o 255us
delay0255
	movlw h'53'	; 1
	movwf dpl	; 1  T=dpl * 3cycle
delay0255_0				; funkcja opoxnienia 0 255us
	decfsz dpl, 1		; 1(2 cykle jesli 0)
	goto delay0255_0	; 2
	return
;opoznienie o 10 ms
delay10
	movlw h'0b'		;1 bylo 0bh
delay10a
	movwf dph		;1
	movlw h'f2'		;1
delay10b
	movwf dpl	;przepisuja W do dpl
	decfsz dpl,0		;1 dekrement, wynik do W, jesli 0 pomin next instr.
	goto delay10b	;1
	movlw dph	;	wpisz do W dph
	decfsz dph,0	;1 zmniejsz dph, wynik do W, jesli 0 pomin next instr.
	goto delay10a	;1
	return	
;opoznienie o 100ms
delay100ms
	movwf stos3 	;zapamietuje W na stosie
	movlw .10
	movwf licznik
	call delay10
	decfsz licznik, 1
	goto $-2
	movf stos3, 0	;oddaje wartosc W
	return
;
delay500
	call delay100ms
	call delay100ms
	call delay100ms
	call delay100ms
	call delay100ms
	return
;
;$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
;		DS18B20
;***********************************************
;inicjalizadja ds18b20
INIT_DS
	bcf status, rp1		;bank1
	bsf status, rp0		;bank1
	movlw b'11000000'			
	movwf trisa			;RA0 := wyjscie
	bcf status, rp1		;bank1
	bcf status, rp0		;bank0
	bcf DS_DATA			; master rest pulse
	call delay1
	bsf DS_DATA			; master rest pulse
	bcf status, rp1		;bank1
	bsf status, rp0		;bank1
	movlw b'11001000'			
	movwf trisa			;RA0 := wejscie
	bcf status, rp1		;bank1
	bcf status, rp0		;bank0
	call delay100		;odczekaj 100us
	btfsc DS_DATA		; odczytaj potwierdzenie obecno DS
	goto $-1
INIT_DS1
	call delay60
	btfss DS_DATA		; odczytaj ZWOLNIENIE linii danych DS
	goto INIT_DS1
	call delay60
	return
; zapis slowa spod DS_WORD do DS18B20 - od LSB do MSB
WR_DS
	bcf status, rp1		;bank1
	bsf status, rp0		;bank1
	movlw b'11000000'			
	movwf trisa			;RA0 := wyjscie
	bcf status, rp1		;bank1
	bcf status, rp0		;bank0
	bsf DS_DATA
	NOP;1uS
	NOP;1uS
	bcf DS_DATA	; stgna start transmisji
	btfss DS_WORD, 0
	goto WR_DS1
	bsf DS_DATA
	goto WR_DS1a
WR_DS1
	bcf DS_DATA
WR_DS1a
	call delay60
	bsf DS_DATA
	NOP;2uS
	NOP;
	bcf DS_DATA
	NOP;2uS
	NOP;
	btfss DS_WORD, 1
	goto WR_DS2
	bsf DS_DATA
	goto WR_DS2a
WR_DS2
	bcf DS_DATA
WR_DS2a
	call delay60
	bsf DS_DATA
	NOP;2uS
	NOP;
	bcf DS_DATA
	NOP;2uS
	NOP;
	btfss DS_WORD, 2
	goto WR_DS3
	bsf DS_DATA
	goto WR_DS3a
WR_DS3
	bcf DS_DATA
WR_DS3a
	call delay60
	bsf DS_DATA
	NOP;2uS
	NOP;
	bcf DS_DATA
	NOP;2uS
	NOP;
	btfss DS_WORD, 3
	goto WR_DS4
	bsf DS_DATA
	goto WR_DS4a
WR_DS4
	bcf DS_DATA
WR_DS4a
	call delay60
	bsf DS_DATA
	NOP;2uS
	NOP;
	bcf DS_DATA
	NOP;2uS
	NOP;
	btfss DS_WORD, 4
	goto WR_DS5
	bsf DS_DATA
	goto WR_DS5a
WR_DS5
	bcf DS_DATA
WR_DS5a
	call delay60
	bsf DS_DATA
	NOP;2uS
	NOP;
	bcf DS_DATA
	NOP;2uS
	NOP;
	btfss DS_WORD, 5
	goto WR_DS6
	bsf DS_DATA
	goto WR_DS6a
WR_DS6
	bcf DS_DATA
WR_DS6a
	call delay60
	bsf DS_DATA
	NOP;2uS
	NOP;
	bcf DS_DATA
	NOP;2uS
	NOP;
	btfss DS_WORD, 6
	goto WR_DS7
	bsf DS_DATA
	goto WR_DS7a
WR_DS7
	bcf DS_DATA
WR_DS7a
	call delay60
	bsf DS_DATA
	NOP;2uS
	NOP;
	bcf DS_DATA
	NOP;2uS
	NOP;
	btfss DS_WORD, 7
	goto WR_DS8
	bsf DS_DATA
	goto WR_DS8a
WR_DS8
	bcf DS_DATA
WR_DS8a
	call delay60
	bsf DS_DATA
	call delay60
	call delay60
	return
;FUNKCJA ODCZYTU BAJTU Z ds I ZAPISU DO ACC
RD_DS
	bcf status, rp1		;bank1
	bsf status, rp0		;bank1
	movlw b'11000000'			
	movwf trisa			;RA0 := wyjscie
	bcf status, rp1		;bank1
	bcf status, rp0		;bank0
	bsf DS_DATA
	NOP;2uS
	NOP;
	bcf DS_DATA
	NOP;2uS
	NOP;
	bcf status, rp1		;bank1
	bsf status, rp0		;bank1
	movlw b'11001000'			
	movwf trisa			;RA0 := wejscie
	bcf status, rp1		;bank1
	bcf status, rp0		;bank0
;
	movlw h'03'	; 1
	movwf dpl	;1
	decfsz dpl, 1		;1
	goto $-1	;1
;
	clrf DS_WORD
	btfsc DS_DATA
	bsf DS_WORD, 0
;
	call delay60
;
	bcf status, rp1		;bank1
	bsf status, rp0		;bank1
	movlw b'11000000'			
	movwf trisa			;RA0 := wyjscie
	bcf status, rp1		;bank1
	bcf status, rp0		;bank0
	bsf DS_DATA
	NOP;2uS
	NOP;
	bcf DS_DATA
	NOP;2uS
	NOP;
	bcf status, rp1		;bank1
	bsf status, rp0		;bank1
	movlw b'11001000'			
	movwf trisa			;RA0 := wejscie
	bcf status, rp1		;bank1
	bcf status, rp0		;bank0
;
	movlw h'03'	; 1
	movwf dpl	;1
	decfsz dpl, 1		;1
	goto $-1	;1
;
	btfsc DS_DATA
	bsf DS_WORD, 1
;
	call delay60
;
	bcf status, rp1		;bank1
	bsf status, rp0		;bank1
	movlw b'11000000'			
	movwf trisa			;RA0 := wyjscie
	bcf status, rp1		;bank1
	bcf status, rp0		;bank0
	bsf DS_DATA
	NOP;2uS
	NOP;
	bcf DS_DATA
	NOP;2uS
	NOP;
	bcf status, rp1		;bank1
	bsf status, rp0		;bank1
	movlw b'11001000'			
	movwf trisa			;RA0 := wejscie
	bcf status, rp1		;bank1
	bcf status, rp0		;bank0
;
	movlw h'03'	; 1
	movwf dpl	;1
	decfsz dpl, 1		;1
	goto $-1	;1
;
	btfsc DS_DATA
	bsf DS_WORD, 2
;
	call delay60;
;
	bsf DS_DATA;
	bcf status, rp1		;bank1
	bsf status, rp0		;bank1
	movlw b'11000000'			
	movwf trisa			;RA0 := wyjscie
	bcf status, rp1		;bank1
	bcf status, rp0		;bank0
	bsf DS_DATA
	NOP;2uS
	NOP;
	bcf DS_DATA
	NOP;2uS
	NOP;
	bcf status, rp1		;bank1
	bsf status, rp0		;bank1
	movlw b'11001000'			
	movwf trisa			;RA0 := wejscie
	bcf status, rp1		;bank1
	bcf status, rp0		;bank0
;
	movlw h'03'	; 1
	movwf dpl	;1
	decfsz dpl, 1		;1
	goto $-1	;1
;
	btfsc DS_DATA
	bsf DS_WORD, 3
;
	call delay60
;
	bcf status, rp1		;bank1
	bsf status, rp0		;bank1
	movlw b'11000000'			
	movwf trisa			;RA0 := wyjscie
	bcf status, rp1		;bank1
	bcf status, rp0		;bank0
	bsf DS_DATA
	NOP;2uS
	NOP;
	bcf DS_DATA
	NOP;2uS
	NOP;
	bcf status, rp1		;bank1
	bsf status, rp0		;bank1
	movlw b'11001000'			
	movwf trisa			;RA0 := wejscie
	bcf status, rp1		;bank1
	bcf status, rp0		;bank0
;
	movlw h'03'	; 1
	movwf dpl	;1
	decfsz dpl, 1		;1
	goto $-1	;1
;
	btfsc DS_DATA
	bsf DS_WORD, 4
;
	call delay60
;
	bcf status, rp1		;bank1
	bsf status, rp0		;bank1
	movlw b'11000000'			
	movwf trisa			;RA0 := wyjscie
	bcf status, rp1		;bank1
	bcf status, rp0		;bank0
	bsf DS_DATA
	NOP;2uS
	NOP;
	bcf DS_DATA
	NOP;2uS
	NOP;
	bcf status, rp1		;bank1
	bsf status, rp0		;bank1
	movlw b'11001000'			
	movwf trisa			;RA0 := wejscie
	bcf status, rp1		;bank1
	bcf status, rp0		;bank0
;
	movlw h'03'	; 1
	movwf dpl	;1
	decfsz dpl, 1		;1
	goto $-1	;1
;
	btfsc DS_DATA
	bsf DS_WORD, 5
;
	call delay60
;
	bcf status, rp1		;bank1
	bsf status, rp0		;bank1
	movlw b'11000000'			
	movwf trisa			;RA0 := wyjscie
	bcf status, rp1		;bank1
	bcf status, rp0		;bank0
	bsf DS_DATA
	NOP;2uS
	NOP;
	bcf DS_DATA
	NOP;2uS
	NOP;
	bcf status, rp1		;bank1
	bsf status, rp0		;bank1
	movlw b'11001000'			
	movwf trisa			;RA0 := wejscie
	bcf status, rp1		;bank1
	bcf status, rp0		;bank0
;
	movlw h'03'	; 1
	movwf dpl	;1
	decfsz dpl, 1		;1
	goto $-1	;1
;
	btfsc DS_DATA
	bsf DS_WORD, 6
;
	call delay60
;
	bcf status, rp1		;bank1
	bsf status, rp0		;bank1
	movlw b'11000000'			
	movwf trisa			;RA0 := wyjscie
	bcf status, rp1		;bank1
	bcf status, rp0		;bank0
	bsf DS_DATA
	NOP;2uS
	NOP;
	bcf DS_DATA
	NOP;2uS
	NOP;
	bcf status, rp1		;bank1
	bsf status, rp0		;bank1
	movlw b'11001000'			
	movwf trisa			;RA0 := wejscie
	bcf status, rp1		;bank1
	bcf status, rp0		;bank0
;
	movlw h'03'	; 1
	movwf dpl	;1
	decfsz dpl, 1		;1
	goto $-1	;1
;
	btfsc DS_DATA
	bsf DS_WORD, 7
;
	call delay60
;
	bsf DS_DATA	;
	bcf status, rp1		;bank1
	bsf status, rp0		;bank1
	movlw b'11000000'			
	movwf trisa			;RA0 := wyjscie
	bcf status, rp1		;bank1
	bcf status, rp0		;bank0
	bsf DS_DATA	
	call delay100
	return
;opoznienie o 60us
delay60
	movlw h'14'	; 1
	movwf dpl	; 1  T=dpl * 3cycle
delay60_0				; funkcja opoxnienia 0 255us
	decfsz dpl, 1		; 1(2 cykle jesli 0)
	goto delay60_0
	return
;opoznienie o 100us
delay100
	movlw h'21'	; 1
	movwf dpl	; 1  T=dpl * 3cycle
delay100_0				; funkcja opoxnienia 0 255us
	decfsz dpl, 1		; 1(2 cykle jesli 0)
	goto delay100_0
	return
;opoznienie o 1ms
delay1
	call delay0255
	call delay0255
	call delay0255
	call delay0255
	return ;896
;****************************************
; funkcja pomiaru temperatury
POM
;obsuga DS18B20
	CALL INIT_DS; inicjalizacja DS18B20
	movlw READ_ROM;uC wysyla komende READ_ROM (33H)
	movwf DS_WORD
	CALL WR_DS;funkcja zapisu A do ds
	movlw h'08'
	movwf licznik
POM0
	CALL RD_DS ;odczyt pierwszego bajtu - famili code 028H
	decfsz licznik, 1
	goto POM0
;
	movlw CONVERT_TEMPERATURE;uC wysyla komende )
	movwf DS_WORD
;
	CALL WR_DS;funkcja zapisu A do ds
	bcf status, rp1		;bank1
	bsf status, rp0		;bank1
	movlw b'11001000'			
	movwf trisa			;RA0 := wejscie 
	bcf status, rp1		;bank1
	bcf status, rp0		;bank0
POM1b
	movlw h'04'	; 1
	movwf dpl	;1
	decfsz dpl, 1		;1
	goto $-1	;1
	btfss DS_DATA
	goto POM1b
;	
	CALL INIT_DS; inicjalizacja DS18B20
	movlw READ_ROM;uC wysyla komende READ_ROM (33H)
	movwf DS_WORD
	CALL WR_DS;funkcja zapisu A do ds
;
	movlw h'08'
	movwf licznik
POM1a
	CALL RD_DS ;odczyt pierwszego bajtu - famili code 028H
	decfsz licznik, 1
	goto POM1a ;
	movlw READ_SCRATCHPAD
	movwf DS_WORD
	CALL WR_DS
;
	CALL RD_DS ;TEMP. lsb
;
	rrf DS_WORD, 1
	rrf DS_WORD, 1
	rrf DS_WORD, 1
	rrf DS_WORD, 1
	movlw h'0F'
	andwf DS_WORD, 0
	movwf pom1		;wynik lsb gdzie x.7 x.6 x.5 =0
;
	CALL RD_DS ;TEMP. MSB
;
	rlf DS_WORD, 1	;D6 D5 D4 D3 D2 D1 D0 C
	rlf DS_WORD, 1	;D5 D4 D3 D2 D1 D0 C C
	rlf DS_WORD, 1	;D4 D3 D2 D1 D0 C C C
	rlf DS_WORD, 0	;D3 D2 D1 D0 C C C C
	andlw b'01110000'
	iorwf pom1, 0
	movwf DS_WORD
	call counter		;obliczanie wyniku
	incf DS_WORD, 1	;
	return
;przeliczenie wartosci z DS na 3xbcd
counter
	bcf status, rp0	;powrot do bank0
	bcf status, rp1	;powrot do bank0
	clrf x1000s ;setki	
	clrf x100s	;dziesiatki
	clrf x10s 	;jednosci
	btfsc DS_WORD, 7
	goto counter_end2	;blad pomiaru
	btfss DS_WORD, 6	;+64
	goto counter1
	movlw h'06'
	movwf x100s
	movlw h'04'
	movwf x10s
counter1
	btfss DS_WORD, 5	;+32
	goto counter2
	movlw h'03'		;
	addwf x100s, 1
	movlw h'02'		;
	addwf x10s, 1
counter2
	btfss DS_WORD, 4	;+16
	goto counter3
	movlw h'06'		;	;+6 z 16
	addwf x10s, 1
	movlw h'09'		;poprawka dziesietna
	subwf x10s, 0
	btfsc status, z
	goto counter2a	; jendosci si przepeniy
	btfss status, c
	goto counter2a
	movlw h'0A'		;poprawka dziesietna
	subwf x10s, 1	
	incf x100s ;
counter2a				;+10 z 16
	movlw h'01'		;	;+6 z 16
	addwf x100s, 1
	movlw h'09'		;poprawka dziesietna
	subwf x100s, 0
	btfsc status, z
	goto counter3
	btfss status, c
	goto counter3
	movlw h'0A'		;poprawka dziesietna
	subwf x100s, 1	
	incf x1000s 
counter3			;+8
	btfss DS_WORD, 3	
	goto counter4
	movlw h'08'		;	
	addwf x10s, 1
	movlw h'09'		;poprawka dziesietna
	subwf x10s, 0
	btfsc status, z
	goto counter4
	btfss status, c
	goto counter4
	movlw h'0A'		;poprawka dziesietna
	subwf x10s, 1	
;
	movlw h'01'		;+16
	addwf x100s, 1	;x10s:=x10s+1
;
	movlw h'09'		;poprawka dziesietna
	subwf x100s, 0
	btfsc status, z
	goto counter4
	btfss status, c
	goto counter4
	movlw h'0A'		;poprawka dziesietna
	subwf x100s, 1	
	incf x1000s 
counter4				;+4
	btfss DS_WORD, 2	
	goto counter5
	movlw h'04'		;	
	addwf x10s, 1
	movlw h'09'		;poprawka dziesietna
	subwf x10s, 0
	btfsc status, z
	goto counter5
	btfss status, c
	goto counter5
	movlw h'0A'		;poprawka dziesietna
	subwf x10s, 1	
;
	movlw h'01'		;
	addwf x100s, 1	;x10s:=x10s+1
;
	movlw h'09'		;poprawka dziesietna
	subwf x100s, 0
	btfsc status, z
	goto counter5
	btfss status, c
	goto counter5
	movlw h'0A'		;poprawka dziesietna
	subwf x100s, 1	
	incf x1000s 
;
counter5				;+2
	btfss DS_WORD, 1	
	goto counter6	;
	movlw h'02'		;	
	addwf x10s, 1
	movlw h'09'		;poprawka dziesietna
	subwf x10s, 0
	btfsc status, z
	goto counter6;
	btfss status, c
	goto counter6
	movlw h'0A'		;poprawka dziesietna
	subwf x10s, 1	
;
	movlw h'01'		;
	addwf x100s, 1	;x10s:=x10s+1
;
	movlw h'09'		;poprawka dziesietna
	subwf x100s, 0
	btfsc status, z
	goto counter6
	btfss status, c
	goto counter6
	movlw h'0A'		;poprawka dziesietna
	subwf x100s, 1	
	incf x1000s 
counter6
	btfss DS_WORD, 0	
	goto counter_end2	;
	movlw h'01'		;	
	addwf x10s, 1
	movlw h'09'		;poprawka dziesietna
	subwf x10s, 0
	btfsc status, z
	goto counter_end2;
	btfss status, c
	goto counter_end2
	movlw h'0A'		;poprawka dziesietna
	subwf x10s, 1	
;
	movlw h'01'		;
	addwf x100s, 1	;x10s:=x10s+1
;
	movlw h'09'		;poprawka dziesietna
	subwf x100s, 0
	btfsc status, z
	goto counter_end2
	btfss status, c
	goto counter6
	movlw h'0A'		;poprawka dziesietna
	subwf x100s, 1	
	incf x1000s 
counter_end2
	btfsc x1000s, 0
	goto counter_end1
	btfsc x100s, 0
	goto counter_end1
	btfsc x100s, 1
	goto counter_end1
	btfsc x100s, 2
	goto counter_end1
	btfsc x100s, 3
	goto counter_end1
	movlw h'0b'		;ciemna cyfra
	movwf x100s
;
counter_end1
	return
;PORWNANIE TEMPERATURY
COMPARE_TEMP
	movf temp_ref, 0
;	movlw h'1f'	;31C
	addlw h'01'
	bcf status, C
	subwf DS_WORD, 0
	btfss status, C
	goto COMPARE_TEMP_END
	bsf dp2	
	bcf status, rp1		;bank1
	bsf status, rp0		;bank0
	clrf option_reg
	bcf status, rp0		;bank0
	movlw h'80'	;
	movwf int_div
;BUZ=>on - option_reg:=00 bank1, int_div:=80h (byl 08h)
COMPARE_TEMP_END
	return
;
;odczyt z eeprom spod adr_eeprom, dana zapisana do W
eeprom_read
	bcf status, rp0 ;bank0
	bcf status, rp1 ;bank2
;	movf adr_eeprom, 0		;!!!!!!!!!!!!!!!!!!!!
	movlw h'00'
	bsf status, rp1 ;bank2
	movwf eeadr		;
	clrf eeadrh
	bsf status, rp0 ;bank3
	bcf eecon1, eepgd
	bsf eecon1, rd	;odczyt z eeprom
	btfsc eecon1, rd
	goto $-1
	bcf status, rp0 ;bank2
	movf eedata, 0	;przepisanie odczytanej danej do w
	clrf eeadr		;zerowy adres
	bcf status, rp1 ;bank0
;	movwf pom1
	return
;zapis do adresu adr_eeprom, dane w  W; 
eeprom_write
	bcf status, rp0 ;bank0
	bsf status, rp1 ;bank2
	movwf eedata	;wyslanie danych do eedata
	bcf status, rp1 ;bank0
;	movf adr_eeprom, 0	;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	movlw h'00'
	bsf status, rp1 ;bank2
	movwf eeadr		;
	clrf eeadrh
	bsf status, rp0 ;bank3
	bcf eecon1, eepgd
	bsf eecon1,wren	;zezwolenie na zapis
	movlw h'55'
	movwf eecon2
	movlw h'aa'
	movwf eecon2
	bsf eecon1,wr	;rozpoczecie zapisu
	btfsc eecon1, wr	;oczekiwanie na koniec zapisu
	goto $-1
	bcf eecon1, wren	;wyl. zezwolenia na zapis
;
	bcf status, rp0 ;bank2
	clrf eeadr		;zerowy adres
;
	bcf status, rp1	;powrot do bank0
	return
;
	end